"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReferralTest(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "clinicalIndicationTest",
        "interpreter",
        "priority",
        "processingLab",
        "referralTestId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import participant as participant_1_5_0

        return {
            "analysisPanels": participant_1_5_0.AnalysisPanel,
            "clinicalIndicationTest": participant_1_5_0.ClinicalIndicationTest,
            "diseasePenetrances": participant_1_5_0.DiseasePenetrance,
            "failedCollectionSamples": participant_1_5_0.FailedCollectionSample,
            "germlineSamples": participant_1_5_0.GermlineSample,
            "interpreter": participant_1_5_0.OrganisationNgis,
            "matchedSamples": participant_1_5_0.MatchedSamples,
            "pipelineStartDate": participant_1_5_0.Date,
            "processingLab": participant_1_5_0.OrganisationNgis,
            "referralTestOrderingDate": participant_1_5_0.Date,
            "tumourSamples": participant_1_5_0.TumourSample,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import participant as participant_1_5_0

        return {
            "priority": participant_1_5_0.Priority,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.AnalysisPanel": participant_1_5_0.AnalysisPanel,
            "org.gel.models.participant.avro.ClinicalIndicationTest": participant_1_5_0.ClinicalIndicationTest,
            "org.gel.models.participant.avro.DiseasePenetrance": participant_1_5_0.DiseasePenetrance,
            "org.gel.models.participant.avro.FailedCollectionSample": participant_1_5_0.FailedCollectionSample,
            "org.gel.models.participant.avro.GermlineSample": participant_1_5_0.GermlineSample,
            "org.gel.models.participant.avro.OrganisationNgis": participant_1_5_0.OrganisationNgis,
            "org.gel.models.participant.avro.MatchedSamples": participant_1_5_0.MatchedSamples,
            "org.gel.models.participant.avro.Date": participant_1_5_0.Date,
            "org.gel.models.participant.avro.Priority": participant_1_5_0.Priority,
            "org.gel.models.participant.avro.OrganisationNgis": participant_1_5_0.OrganisationNgis,
            "org.gel.models.participant.avro.Date": participant_1_5_0.Date,
            "org.gel.models.participant.avro.TumourSample": participant_1_5_0.TumourSample,
            "org.gel.models.participant.avro.ReferralTest": participant_1_5_0.ReferralTest,
        }

    __slots__ = [
        "clinicalIndicationTest",
        "interpreter",
        "priority",
        "processingLab",
        "referralTestId",
        "analysisPanels",
        "diseasePenetrances",
        "failedCollectionSamples",
        "germlineSamples",
        "matchedSamples",
        "pipelineStartDate",
        "referralTestOrderingDate",
        "tumourSamples",
    ]

    def __init__(
        self,
        clinicalIndicationTest,
        interpreter,
        priority,
        processingLab,
        referralTestId,
        analysisPanels=None,
        diseasePenetrances=None,
        failedCollectionSamples=None,
        germlineSamples=None,
        matchedSamples=None,
        pipelineStartDate=None,
        referralTestOrderingDate=None,
        tumourSamples=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.ReferralTest model.

        :param clinicalIndicationTest:
            Clinical indication test
        :type clinicalIndicationTest: ClinicalIndicationTest
        :param interpreter:
            Organisation assigned for the interpretation of this test
        :type interpreter: OrganisationNgis
        :param priority:
            Priority
        :type priority: Priority
        :param processingLab:
            Organisation assigned for the processing of the test
        :type processingLab: OrganisationNgis
        :param referralTestId:
            Test UID
        :type referralTestId: str
        :param analysisPanels:
            List of Analysis panels
        :type analysisPanels: None | list[AnalysisPanel]
        :param diseasePenetrances:
            Disease Penetrance applied for that referralTest
        :type diseasePenetrances: None | list[DiseasePenetrance]
        :param failedCollectionSamples:
            List of all samples that were failed to be collected and their
            details.
        :type failedCollectionSamples: None | list[FailedCollectionSample]
        :param germlineSamples:
            List of all germline samples aplicable to this test
        :type germlineSamples: None | list[GermlineSample]
        :param matchedSamples:
            List of matched samples (i.e.: pairs tumour-germline)
        :type matchedSamples: None | list[MatchedSamples]
        :param pipelineStartDate:
            Date of ordering. NOTE: this field is not required from upstream
            and will be generated by Bioinformatics when all sample
            data and all         required clinical data is received
            for the first time
        :type pipelineStartDate: None | Date
        :param referralTestOrderingDate:
            The date of which the referralTest was sent to Bioinformatics
        :type referralTestOrderingDate: None | Date
        :param tumourSamples:
            List of all somatic samples applicable to this test
        :type tumourSamples: None | list[TumourSample]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
